/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __DEMO_DESCRIPTION_H_
#define __DEMO_DESCRIPTION_H_

#include "gdamchannel.h"
/*
 * This structure is primarily built by the demos/make-demo-list.pl
 * script, which parses through the description comments
 * of the .c file in the demos/ directory.
 */

/* TODO:  write doc about format of description comments.  cite it here. */

#define DEMO_VERSION		0

typedef struct _DemoDescription DemoDescription;

struct _DemoDescription {
	int demo_version;
	const char* description;

	void    (*run_demo)(GdamChannel*           channel,
                            guint                  mixer_id);
};

/* Someday, this function may support old ways to run the demo,
 * using `demo_version', for now it just calls `run_demo'. */
void demo_description_run(DemoDescription*   description,
                          GdamChannel*       channel,
	                  guint              mixer_id);

#endif
