/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_INPUT_HOOK_H_
#define __GDAM_INPUT_HOOK_H_

#include <gtk/gtkadjustment.h>

typedef guint (*GdamInputAdjustmentHandler)(GtkAdjustment*    adjustment,
                                           const char*       input_options);
typedef void  (*GdamInputRemoveHandler)   (guint             handler_id);

guint    gdam_input_hook_add_adjustment   (GtkAdjustment*    adjustment,
                                           const char*       input_class,
					   const char*       input_options);
void     gdam_input_hook_remove           (const char*       input_class,
                                           guint             hook_id);

void     gdam_input_hook_register_class   (const char*       input_class,
                                           GdamInputAdjustmentHandler handler,
					   GdamInputRemoveHandler remover);

#endif

