/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_CACHE_H_
#define __GDAM_CACHE_H_

typedef struct _GdamCache GdamCache;

#include "gdamsource.h"
#include "gdamcachebuffer.h"

GtkType gdam_cache_get_type ();
#define GDAM_TYPE_CACHE              (gdam_cache_get_type ())
#define GDAM_CACHE(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_CACHE, GdamCache))

struct _GdamCache {
	GdamSource		source;
	GdamCacheBuffer*	cache;
	int			cache_index;
	int			remaining;
	gboolean		should_loop;
};

GdamCache*		gdam_cache_new		(guint             cache_id,
                                                 gboolean          loop);

#endif
