#ifndef __GDAM_SECOND_ORDER_FILTER_H_
#define __GDAM_SECOND_ORDER_FILTER_H_


typedef struct _GdamSecondOrderFilter GdamSecondOrderFilter;
typedef struct _GdamSecondOrderFilterClass GdamSecondOrderFilterClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamfilter.h"

GtkType gdam_second_order_filter_get_type();
#define GDAM_TYPE_SECOND_ORDER_FILTER			(gdam_second_order_filter_get_type ())
#define GDAM_SECOND_ORDER_FILTER(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SECOND_ORDER_FILTER, GdamSecondOrderFilter))
#define GDAM_SECOND_ORDER_FILTER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SECOND_ORDER_FILTER, GdamSecondOrderFilterClass))
#define GDAM_IS_SECOND_ORDER_FILTER(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SECOND_ORDER_FILTER))
#define GDAM_IS_SECOND_ORDER_FILTER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SECOND_ORDER_FILTER))

struct _GdamSecondOrderFilterClass {
	GdamFilterClass		filter_class;
};

struct _GdamSecondOrderFilter {
	GdamFilter		filter;

	int			max_length;

	int       		in_first_order_length;
	GdamFixed*		in_first_order;
	int       		in_second_order_length;
	GdamFixed*		in_second_order;

	int       		out_first_order_length;
	GdamFixed*		out_first_order;
	int       		out_second_order_length;
	GdamFixed*		out_second_order;

	GdamSample*		past_in;
	GdamSample*		past_out;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
